% hotely(ZOZNAM) - zoznam hotelov cez ktore sa hlada optimalne riesenie
% hotel(NAZOV, VZDIALENOST, CENA_ZA_NOC, POCET_DNI_OD_OTVORENIA) - blizsie info o hoteloch
%fcia_vz(MIN,MAX,HODNOTA,VZDIALENOST) - tato fcia rata pre VZDIALEOST<MIN HODNOTU=1,
%                                       pre VZDIALENOST>MAX HODNOTA=0, inak linearna fcia 
%fcia_cena(MIN, MAX, HODNOTA, CENA) - tato fcia rata pre CENU<MIN HODNOTU=1,
%                                       pre CENU>MAX HODNOTA=0, inak linearna fcia
%fcia_novost(MIN, MAX,HODNOTA, POCET_DNI) - tato fcia rata pre POCET_DNI<MIN HODNOTU=1,
%                                       pre POCET_DNI>MAX HODNOTA=0, inak linearna fcia
%prirad(HOTEL,VZ_MIN,VZ_MAX, CENA_MIN, CENA_MAX, POCET_DNI_MIN, POCET_DNI_MAX,VYSLEDOK)
%prirad pocita vo VYSLEDKu ako velmi dany hotel vyhovuje v intervale <0,1>.
%najdi(HOTEL, VYSLEDOK, VZ_MIN, VZ_MAX, Cena-min, CENA_MAX, POCET_DNI_MIN, POCET_DNI_MAX)
%najdi nam najde najlepsie riesenie pre pozadovane poziadavky

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

hotely([slovan,forum,hoges,elektra,dukla,baracka]).

hotel(slovan, 150, 1200, 14523).
hotel(forum, 200, 1000, 17800).
hotel(hoges, 950, 500, 17000).
hotel(elektra, 1000, 750, 12030).
hotel(dukla, 960, 520, 12000).
hotel(baracka, 420, 600, 10200).


fcia_vz(A,B,C,D):-D<A, C is 1.        
fcia_vz(A,B,C,D):-D>B, C is 0.
fcia_vz(A,B,C,D):-not(D<A), not(D>B), C is(D/(A-B)+1-A/(A-B)).


fcia_cena(A,B,C,D):-D<A, C is 1.   
fcia_cena(A,B,C,D):-D>B, C is 0.
fcia_cena(A,B,C,D):-not(D<A), not(D>B), C is(D/(A-B)+1-A/(A-B)).


fcia_novost(A,B,C,D):-D<A, C is 1.
fcia_novost(A,B,C,D):-D>B, C is 0.
fcia_novost(A,B,C,D):-not(D<A), not(D>B), C is(D/(A-B)+1-A/(A-B)).


prirad(A,V_MIN,V_MAX,C_MIN,C_MAX,N_MIN,N_MAX,V):-hotel(A,B,C,D),fcia_vz(V_MIN,V_MAX,V1,B),fcia_cena(C_MIN,C_MAX,V2,C),
                                                 fcia_novost(N_MIN,N_MAX,V3,D),V is ((V1+V2+V3)/3).


najdi(HOT,VYS,V_MIN,V_MAX,C_MIN,C_MAX,N_MIN,N_MAX):-hotely(C),best(HOT,VYS,C,V_MIN,V_MAX,C_MIN,C_MAX,N_MIN,N_MAX).




best(ziadny,0,[],V_MIN,V_MAX,C_MIN,C_MAX,N_MIN,N_MAX).

best(A,V1,[A|B],V_MIN,V_MAX,C_MIN,C_MAX,N_MIN,N_MAX):-best(HOT,V2,B,V_MIN,V_MAX,C_MIN,C_MAX,N_MIN,N_MAX),
                                                         prirad(A,V_MIN,V_MAX,C_MIN,C_MAX,N_MIN,N_MAX,V1),V1>V2.


best(HOT,V2,[A|B],V_MIN,V_MAX,C_MIN,C_MAX,N_MIN,N_MAX):-best(HOT,V2,B,V_MIN,V_MAX,C_MIN,C_MAX,N_MIN,N_MAX),
                                                         prirad(A,V_MIN,V_MAX,C_MIN,C_MAX,N_MIN,N_MAX,V1),not(V1>V2).

